	cpu LMM
	.module sensor.c
	.area lit(rom, con, rel)
_FactoryDefault_Param_8::
	.byte 0,0
	.byte 0
	.dbfile ./sensor.c
	.dbsym e FactoryDefault_Param_8 _FactoryDefault_Param_8 A[3:3]c
_FactoryDefault_Param_16::
	.word 500
	.word 500
	.word 50000
	.dbsym e FactoryDefault_Param_16 _FactoryDefault_Param_16 A[6:3]i
_FactoryDefault_Param_32::
	.word 0,0
	.dbsym e FactoryDefault_Param_32 _FactoryDefault_Param_32 A[4:1]l
_FactoryDefault_Param_168::
	.byte 'D,'i,'s,'t,'a,'n,'c,'e,32,'S,'e,'n,'s,'o,'r,0
	.byte 0,0,0,0,0
	.byte 'F,'r,'a,'m,'e,32,'N,'u,'m,'b,'e,'r,0
	.byte 0,0,0,0,0,0,0,0
	.byte 'D,'i,'s,'t,'a,'n,'c,'e,0
	.word 0,0,0,0,0
	.byte 0,0
	.dbsym e FactoryDefault_Param_168 _FactoryDefault_Param_168 A[63:3:21]c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_NewSample::
	.byte 0
	.dbsym e NewSample _NewSample c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
	.area text(rom, con, rel)
	.dbfile ./sensor.c
	.dbfunc e Sensor_Start _Sensor_Start fV
_Sensor_Start::
	.dbline -1
	.dbline 94
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:   sensor.c
; //  Version: 1.0, 2007/03/08
; //  Generated by Andy Kiser
; //
; //  DESCRIPTION:  sensor specific functions 
; //
; //-----------------------------------------------------------------------------
; //  Copyright (c) Toradex AG 2007. All Rights Reserved.
; //*****************************************************************************
; //*****************************************************************************
; //#define __DEBUG__
; #include <m8c.h>        // part specific constants and macros
; #include "sensor.h"
; #include "psocgpioint.h"
; #include "psocapi.h"
; #include "feature.h"
; #include "parameters.h"
; #include "types_n_macros.h"
; //----------------------------------------
; // Sensor parameters
; // Factory Defaults are defined here (NUM_xxx are defined in "sensor.h")
; //----------------------------------------
; const BYTE FactoryDefault_Param_8   [NUM_PARAM_8] =
; {
; 	0x00,			// report mode
; 	0x00,			// LED mode
; 	GP2D12J0000F	// Sensor Type is GP2D12J0000F (80cm)
; };
; 
; const WORD FactoryDefault_Param_16  [NUM_PARAM_16] = 
; {
; 	500,		// report rate [ms]
; 	500,		// sample rate [ms]
; 	50000		// sample rate [us]	(not used for this sensor)
; };
; 
; const DWORD FactoryDefault_Param_32  [NUM_PARAM_32] =
; {
; 	0x00000000	// currently no 32bit parameters
; };
; 
; const tParam_168 FactoryDefault_Param_168 [NUM_PARAM_168] =
; {
; 	"Distance Sensor",	// user device name
; 	"Frame Number",		// user name Channel 0
; 	"Distance"			// user name Channel 1
; };
; 
; 
; //----------------------------------------
; // this module's global variables
; //----------------------------------------
; tReport Report;
; 
; //----------------------------------------
; // constant lookup-table for ADC->physical value conversion
; //----------------------------------------
; 
; //----------------------------------------
; // type definitions
; //----------------------------------------
; 
; typedef enum 
; {	
; 	eReset,
; 	eIdle,
; 	eReadADC,
; 	eCalculating
; } tFSM_Measure;
; 
; //----------------------------------------
; // variables
; 
; tFSM_Measure	FSM;
; WORD			Countdown_1ms;
; 
; BOOL			NewSample = FALSE;
; 
; // store original drivemodes during suspend
; BYTE			DM0_2, DM0_1, DM0_0;
; BYTE			DM2_2, DM2_1, DM2_0;
; BYTE			ARF;
; 
; //----------------------------------------
; // function prototypes
; static int CalculateDistance (WORD ADC);
; 
; //-----------------------------------------------------------------------------
; // Initializes the Sensor 
; //-----------------------------------------------------------------------------
; void Sensor_Start ()
; {
	.dbline 96
; 	// turn on power to the sensor
; 	GPIO_LOW(OFF_nON)
	and REG[0x8],-65
	.dbline 99
; 	
; 	// start ADC sampling
; 	PGA_Start (PGA_HIGHPOWER);
	push X
	mov A,3
	xcall _PGA_Start
	.dbline 100
; 	DelSig_Start (DelSig_MEDPOWER);
	mov A,2
	xcall _DelSig_Start
	.dbline 101
; 	DelSig_StartAD(); 		// Start continous sampling
	xcall _DelSig_StartAD
	pop X
	.dbline 103
; 	
; 	FSM = eReset;
	mov REG[0xd0],>_FSM
	mov [_FSM],0
	.dbline -2
	.dbline 104
; }
L9:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Sensor_Suspend _Sensor_Suspend fV
_Sensor_Suspend::
	.dbline -1
	.dbline 109
; //-----------------------------------------------------------------------------
; // Prepare Sensor for Suspend
; //-----------------------------------------------------------------------------
; void Sensor_Suspend()
; {
	.dbline 111
; 	// stop and power off ADC
; 	DelSig_StopAD();
	push X
	xcall _DelSig_StopAD
	.dbline 112
; 	DelSig_Stop();
	xcall _DelSig_Stop
	.dbline 113
; 	PGA_Stop();
	xcall _PGA_Stop
	pop X
	.dbline 115
; 	// turn off power for the sensor
; 	GPIO_HIGH(OFF_nON)
	or REG[0x8],64
	.dbline 118
; 
; 	// store original drivemodes during  suspend
; 	DM0_2 = PRT0DM2;
	mov A,REG[0x3]
	mov REG[0xd0],>_DM0_2
	mov [_DM0_2],A
	.dbline 119
; 	DM0_1 = PRT0DM1;
	or F,0x10  ; iopage = 1
	mov A,REG[0x1]
	mov REG[0xd0],>_DM0_1
	mov [_DM0_1],A
	and F,0xEF ; iopage = 0
	.dbline 120
; 	DM0_0 = PRT0DM0;
	or F,0x10  ; iopage = 1
	mov A,REG[ 0]
	mov REG[0xd0],>_DM0_0
	mov [_DM0_0],A
	and F,0xEF ; iopage = 0
	.dbline 121
; 	DM2_2 = PRT2DM2;
	mov A,REG[0xb]
	mov REG[0xd0],>_DM2_2
	mov [_DM2_2],A
	.dbline 122
; 	DM2_1 = PRT2DM1;
	or F,0x10  ; iopage = 1
	mov A,REG[0x9]
	mov REG[0xd0],>_DM2_1
	mov [_DM2_1],A
	and F,0xEF ; iopage = 0
	.dbline 123
; 	DM2_0 = PRT2DM0;
	or F,0x10  ; iopage = 1
	mov A,REG[0x8]
	mov REG[0xd0],>_DM2_0
	mov [_DM2_0],A
	and F,0xEF ; iopage = 0
	.dbline 125
; 	// store Analog power settings
; 	ARF   = ARF_CR;
	mov A,REG[0x63]
	mov REG[0xd0],>_ARF
	mov [_ARF],A
	.dbline 130
; 	
; 	// set all I/Os to/from the sensor to High-Z Analog (=110), 
; 	// except the OFF_nON signal. 
; 	// OFF_nON is on Port0, all other signals on Port2
; 	PRT0DM2  = 0xFF;
	mov REG[0x3],-1
	.dbline 131
; 	PRT0DM1  = 0xFF;
	or F,0x10  ; iopage = 1
	mov REG[0x1],-1
	and F,0xEF ; iopage = 0
	.dbline 132
; 	PRT0DM0  = 0x00;
	or F,0x10  ; iopage = 1
	mov REG[ 0],0
	and F,0xEF ; iopage = 0
	.dbline 133
; 	PRT2DM2 |= ~OFF_nON_MASK;
	or REG[0xb],-65
	.dbline 134
; 	PRT2DM1 |= ~OFF_nON_MASK;
	or F,0x10  ; iopage = 1
	or REG[0x9],-65
	and F,0xEF ; iopage = 0
	.dbline 135
; 	PRT2DM0 &=  OFF_nON_MASK;
	or F,0x10  ; iopage = 1
	and REG[0x8],64
	and F,0xEF ; iopage = 0
	.dbline -2
	.dbline 137
; 
; }
L10:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Sensor_Resume _Sensor_Resume fV
;       ReadMode -> X+0
_Sensor_Resume::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 142
; //-----------------------------------------------------------------------------
; // Resume Sensor from Suspend mode
; //-----------------------------------------------------------------------------
; void Sensor_Resume()
; {
	.dbline 146
; 	BYTE ReadMode;
; 	
; 	// restore drivemodes for GPIOs to/from the sensor
; 	PRT2DM2 = DM2_2;
	mov REG[0xd0],>_DM2_2
	mov A,[_DM2_2]
	mov REG[0xb],A
	.dbline 147
; 	PRT2DM1 = DM2_1;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM2_1
	mov A,[_DM2_1]
	mov REG[0x9],A
	and F,0xEF ; iopage = 0
	.dbline 148
; 	PRT2DM0 = DM2_0;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM2_0
	mov A,[_DM2_0]
	mov REG[0x8],A
	and F,0xEF ; iopage = 0
	.dbline 150
; 
; 	PRT0DM2 = DM0_2;
	mov REG[0xd0],>_DM0_2
	mov A,[_DM0_2]
	mov REG[0x3],A
	.dbline 151
; 	PRT0DM1 = DM0_1;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM0_1
	mov A,[_DM0_1]
	mov REG[0x1],A
	and F,0xEF ; iopage = 0
	.dbline 152
; 	PRT0DM0 = DM0_0;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM0_0
	mov A,[_DM0_0]
	mov REG[ 0],A
	and F,0xEF ; iopage = 0
	.dbline 154
; 	
; 	ARF_CR = ARF;
	mov REG[0xd0],>_ARF
	mov A,[_ARF]
	mov REG[0x63],A
	.dbline 157
; 
; 	// turn on power for the sensor
; 	Sensor_Start();
	xcall _Sensor_Start
	.dbline 158
; 	FSM = eReset;
	mov REG[0xd0],>_FSM
	mov [_FSM],0
	.dbline -2
	.dbline 159
; }
L11:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l ReadMode 0 c
	.dbend
	.dbfunc e Sensor_Specific_Feature _Sensor_Specific_Feature fc
_Sensor_Specific_Feature::
	.dbline -1
	.dbline 173
; 
; 
; //-----------------------------------------------------------------------------
; // Function that will be called when a FEATURE REPORT is received that 
; // cannot be handled with the standard functionality in feature.c
; // The feature report data is available in the "FEATURE_RPT" variable
; //
; // --> see feature.c for an example how to parse FEATURE_RPT
; //
; //	return Value: number of Parameter bytes (1-31) that are 
; //				  returned in the IN report
; //-----------------------------------------------------------------------------
; BYTE Sensor_Specific_Feature(void)
; {
	.dbline 175
; 	// currently no special feature reports are handled
; 	return 0;
	mov REG[0xd0],>__r0
	mov A,0
	.dbline -2
L12:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Sensor_Specific_Parameter _Sensor_Specific_Parameter fV
; NumberOfReturnedBytes -> X-5
_Sensor_Specific_Parameter::
	.dbline -1
	push X
	mov X,SP
	.dbline 186
; }
; 
; //-----------------------------------------------------------------------------
; // Function that will be called when a FEATURE REPORT is received that 
; // sets / gets a 8/16/32/168bit parameter in feature.c
; // The feature report data is available in the "FEATURE_RPT" variable
; //
; // --> see feature.c for an example how to parse FEATURE_RPT
; //-----------------------------------------------------------------------------
; void Sensor_Specific_Parameter(BYTE *NumberOfReturnedBytes)
; {
	.dbline -2
	.dbline 188
; 	// currently no specific parameters are handled
; }
L13:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l NumberOfReturnedBytes -5 pc
	.dbend
	.dbfunc s GP2D12_ReadADC _GP2D12_ReadADC fi
;           Data -> X+0
_GP2D12_ReadADC:
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 194
; 
; //-----------------------------------------------------------------------------
; // Read ADC 
; //-----------------------------------------------------------------------------
; static WORD GP2D12_ReadADC (void)
; {
	.dbline 197
; 	WORD Data;
; 
; 	if ( DelSig_fIsDataAvailable() )
	push X
	xcall _DelSig_fIsDataAvailable
	mov REG[0xd0],>__r0
	pop X
	cmp A,0
	jz L15
	.dbline 198
; 	{
	.dbline 199
; 		M8C_DisableGInt;
		and F, FEh

	.dbline 200
; 		Data = DelSig_wGetDataClearFlag();	
	push X
	xcall _DelSig_wGetDataClearFlag
	mov REG[0xd0],>__r0
	mov [__r0],X
	pop X
	mov [X+1],A
	mov A,[__r0]
	mov [X+0],A
	.dbline 201
; 		M8C_EnableGInt;
		or  F, 01h

	.dbline 203
; 		
; 		return Data;
	mov A,[X+1]
	mov [__r1],A
	mov A,[X+0]
	mov [__r0],A
	xjmp L14
L15:
	.dbline 206
; 	}
; 	else
; 		return 0xFFFF;
	mov REG[0xd0],>__r0
	mov [__r1],-1
	mov [__r0],-1
	.dbline -2
L14:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l Data 0 i
	.dbend
	.area data(ram, con, rel)
	.dbfile ./sensor.c
L18:
	.byte 0,0
	.area text(rom, con, rel)
	.dbfile ./sensor.c
	.dbfunc e Sensor_FSM_Measure _Sensor_FSM_Measure fV
	.dbsym s ADC L18 i
;     SensorType -> X+2
;       Distance -> X+0
_Sensor_FSM_Measure::
	.dbline -1
	push X
	mov X,SP
	add SP,7
	.dbline 219
; }
; 
; //-----------------------------------------------------------------------------
; // void Sensor_FSM_Measure(void)
; //
; //	finite state machine to control the measurement process for 
; //  the Sensor
; //
; //  IMPORTANT: 	call this routine once every millisecond. Otherwise the timing
; //				parameters cannot be met.
; //-----------------------------------------------------------------------------
; void Sensor_FSM_Measure() 
; {
	.dbline 225
; 	static WORD ADC; // ADC value
; 	WORD 		Distance;
; 	BYTE		SensorType;
; 	
; 	// decrement millisecond counter
; 	if (Countdown_1ms != 0)
	mov REG[0xd0],>_Countdown_1ms
	cmp [_Countdown_1ms],0
	jnz X2
	cmp [_Countdown_1ms+1],0
	jz L19
X2:
	.dbline 226
; 		Countdown_1ms--;
	mov REG[0xd0],>_Countdown_1ms
	dec [_Countdown_1ms+1]
	sbb [_Countdown_1ms],0
L19:
	.dbline 229
; 
; 	// process actual state machine
; 	switch (FSM)
	mov REG[0xd0],>_FSM
	mov A,[_FSM]
	mov [X+4],A
	mov [X+3],0
	cmp [X+3],0
	jnz X3
	cmp [X+4],0
	jz L24
X3:
	cmp [X+3],0
	jnz X4
	cmp [X+4],1
	jz L25
X4:
	cmp [X+3],0
	jnz X5
	cmp [X+4],2
	jz L28
X5:
	cmp [X+3],0
	jnz X6
	cmp [X+4],3
	jz L36
X6:
	xjmp L21
X0:
	.dbline 230
; 	{
L24:
	.dbline 232
; 		case eReset:
; 			Countdown_1ms = 10; // 10ms delay until first measurement finished
	mov REG[0xd0],>_Countdown_1ms
	mov [_Countdown_1ms+1],10
	mov [_Countdown_1ms],0
	.dbline 233
; 			FSM = eIdle;
	mov REG[0xd0],>_FSM
	mov [_FSM],1
	.dbline 234
; 			break;
	xjmp L22
L25:
	.dbline 237
; 			
; 		case eIdle: 
; 			if (Countdown_1ms == 0)
	mov REG[0xd0],>_Countdown_1ms
	cmp [_Countdown_1ms],0
	jnz L22
	cmp [_Countdown_1ms+1],0
	jnz L22
X7:
	.dbline 238
; 			{
	.dbline 239
; 				Get_Param_16(PAR16_SAMPLERATE_MS, VOLATILE, &Countdown_1ms);;
	mov A,>_Countdown_1ms
	push A
	mov A,<_Countdown_1ms
	push A
	mov A,0
	push A
	mov A,1
	push A
	xcall _Get_Param_16
	add SP,-4
	.dbline 239
	.dbline 240
; 				FSM = eReadADC;					  
	mov REG[0xd0],>_FSM
	mov [_FSM],2
	.dbline 241
; 			}
	.dbline 242
; 			break;			
	xjmp L22
L28:
	.dbline 245
; 			
; 		case eReadADC:
; 			Get_Param_8(PAR8_SENSORTYPE, VOLATILE, &SensorType);
	mov REG[0xd0],>__r0
	mov [__r1],X
	add [__r1],2
	mov A,3
	push A
	mov A,[__r1]
	push A
	mov A,0
	push A
	mov A,2
	push A
	xcall _Get_Param_8
	add SP,-4
	.dbline 247
; 
; 			switch(SensorType)
	mov A,[X+2]
	mov [X+6],A
	mov [X+5],0
	cmp [X+5],0
	jnz X8
	cmp [X+6],0
	jz L33
X8:
	cmp [X+5],0
	jnz X9
	cmp [X+6],1
	jz L32
X9:
	mov A,[X+6]
	sub A,0
	mov A,[X+5]
	xor A,-128
	sbb A,(0 ^ 0x80)
	jc L29
X10:
L35:
	cmp [X+5],0
	jnz X11
	cmp [X+6],-1
	jz L34
X11:
	xjmp L29
X1:
	.dbline 248
; 			{
L32:
	.dbline 250
; 				case GP2Y0A41SK0F: // 30cm type
; 					PGA_SetGain(PGA_G0_81); // gain = 0.813
	push X
	mov A,-64
	xcall _PGA_SetGain
	pop X
	.dbline 251
; 					break;
	xjmp L30
L33:
	.dbline 254
; 					
; 				case GP2D12J0000F: // 80cm type
; 					PGA_SetGain(PGA_G1_00);	// gain = 1.000
	push X
	mov A,-8
	xcall _PGA_SetGain
	pop X
	.dbline 255
; 					break;
	xjmp L30
L34:
	.dbline 258
; 				
; 				case 0xFF:	// debug with 80cm type
; 					PGA_SetGain(PGA_G1_00);	// gain = 1.000
	push X
	mov A,-8
	xcall _PGA_SetGain
	pop X
	.dbline 259
; 					break;
L29:
L30:
	.dbline 261
; 			}		
; 			ADC = GP2D12_ReadADC();
	xcall _GP2D12_ReadADC
	mov REG[0xd0],>__r0
	mov A,[__r1]
	push A
	mov A,[__r0]
	mov REG[0xd0],>L18
	mov [L18],A
	pop A
	mov [L18+1],A
	.dbline 262
; 			FSM = eCalculating;
	mov REG[0xd0],>_FSM
	mov [_FSM],3
	.dbline 263
; 			break;			
	xjmp L22
L36:
	.dbline 266
; 
; 		case eCalculating:
; 			Distance = CalculateDistance (ADC);
	mov REG[0xd0],>L18
	mov A,[L18]
	push A
	mov A,[L18+1]
	push A
	xcall _CalculateDistance
	add SP,-2
	mov REG[0xd0],>__r0
	mov A,[__r1]
	mov [X+1],A
	mov A,[__r0]
	mov [X+0],A
	.dbline 268
; 
; 			Report.Ch1_LSB = Distance & 0xFF;
	mov A,[X+1]
	mov REG[0xd0],>_Report
	mov [_Report+2],A
	.dbline 269
; 			Report.Ch1_MSB = Distance / 0x100;
	mov A,[X+0]
	mov [_Report+3],A
	.dbline 274
; 
; //			Report.Ch1_LSB = ADC & 0xFF;
; //			Report.Ch1_MSB = ADC / 0x100;
; 
; 			NewSample = TRUE;
	mov REG[0xd0],>_NewSample
	mov [_NewSample],1
	.dbline 276
; 			
; 			FSM = eIdle;
	mov REG[0xd0],>_FSM
	mov [_FSM],1
	.dbline 277
; 			break;			
L21:
L22:
	.dbline -2
	.dbline 279
; 	}
; }
L17:
	add SP,-7
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l SensorType 2 c
	.dbsym l Distance 0 i
	.dbend
	.dbfunc s CalculateDistance _CalculateDistance fI
;          index -> X+7
;     SensorType -> X+6
;        L_Above -> X+4
;        L_Below -> X+2
;            sum -> X+0
;            ADC -> X-5
_CalculateDistance:
	.dbline -1
	push X
	mov X,SP
	add SP,17
	.dbline 293
; 
; //-----------------------------------------------------------------------------
; // Routine: int CalculateDistance (WORD ADC)
; //
; // Description: Calculate the distance from the ADC output of a IR distance sensor
; //
; // Return: WORD - distance [0.1mm]
; //
; //-----------------------------------------------------------------------------
; extern const WORD ADC2L_80cm[513-64];	// for GP2D12J0000F
; extern const WORD ADC2L_30cm[513];		// for GP2Y0A41SK0F 
; 
; static int CalculateDistance (WORD ADC)
; {
	.dbline 296
; 	BYTE SensorType;
; 	WORD index;
; 	WORD L_Below, L_Above, sum = 0;
	mov [X+1],0
	mov [X+0],0
	.dbline 298
; 	
; 	Get_Param_8(PAR8_SENSORTYPE, VOLATILE, &SensorType);
	mov REG[0xd0],>__r0
	mov [__r1],X
	add [__r1],6
	mov A,3
	push A
	mov A,[__r1]
	push A
	mov A,0
	push A
	mov A,2
	push A
	xcall _Get_Param_8
	add SP,-4
	.dbline 300
; 	
; 	switch(SensorType)
	mov A,[X+6]
	mov [X+10],A
	mov [X+9],0
	cmp [X+9],0
	jnz X13
	cmp [X+10],0
	jz L44
X13:
	cmp [X+9],0
	jnz X14
	cmp [X+10],1
	jz L43
X14:
	mov A,[X+10]
	sub A,0
	mov A,[X+9]
	xor A,-128
	sbb A,(0 ^ 0x80)
	jc L40
X15:
L48:
	cmp [X+9],0
	jnz X16
	cmp [X+10],-1
	jz L47
X16:
	xjmp L40
X12:
	.dbline 301
; 	{
L43:
	.dbline 304
; 		case GP2Y0A41SK0F: // 30cm type
; 			// calculate index into lookup table
; 			index = (ADC -0) >> 3;	
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	mov [__r0],A
	and F,-5
	rrc [__r0]
	rrc [__r1]
	and F,-5
	rrc [__r0]
	rrc [__r1]
	and F,-5
	rrc [__r0]
	rrc [__r1]
	mov A,[__r1]
	mov [X+8],A
	mov A,[__r0]
	mov [X+7],A
	.dbline 305
; 			L_Below = ADC2L_30cm[index];
	mov A,[X+8]
	mov [__r1],A
	mov A,[X+7]
	mov [__r0],A
	asl [__r1]
	rlc [__r0]
	add [__r1],<_ADC2L_30cm
	adc [__r0],>_ADC2L_30cm
	mov A,[__r0]
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	romx
	pop X
	mov [X+3],A
	mov A,[__r0]
	mov [X+2],A
	.dbline 306
; 			L_Above = ADC2L_30cm[index+1];
	mov A,[X+8]
	add A,1
	mov [__r1],A
	mov A,[X+7]
	adc A,0
	mov [__r0],A
	asl [__r1]
	rlc [__r0]
	add [__r1],<_ADC2L_30cm
	adc [__r0],>_ADC2L_30cm
	mov A,[__r0]
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	romx
	pop X
	mov [X+5],A
	mov A,[__r0]
	mov [X+4],A
	.dbline 307
; 			break;
	xjmp L41
L44:
	.dbline 310
; 			
; 		case GP2D12J0000F: // 80cm type
; 			if (ADC <=512)
	mov A,0
	sub A,[X-4]
	mov A,2
	sbb A,[X-5]
	jc L45
X17:
	.dbline 311
; 				index = 0;
	mov [X+8],0
	mov [X+7],0
	xjmp L46
L45:
	.dbline 313
; 			else
; 				index = (ADC-512) >>  3;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	sub A,0
	mov [__r1],A
	mov A,[X-5]
	sbb A,2
	mov [__r0],A
	and F,-5
	rrc [__r0]
	rrc [__r1]
	and F,-5
	rrc [__r0]
	rrc [__r1]
	and F,-5
	rrc [__r0]
	rrc [__r1]
	mov A,[__r1]
	mov [X+8],A
	mov A,[__r0]
	mov [X+7],A
L46:
	.dbline 316
; 				
; 			// do linear interpolation
; 			L_Below = ADC2L_80cm[index];
	mov REG[0xd0],>__r0
	mov A,[X+8]
	mov [__r1],A
	mov A,[X+7]
	mov [__r0],A
	asl [__r1]
	rlc [__r0]
	add [__r1],<_ADC2L_80cm
	adc [__r0],>_ADC2L_80cm
	mov A,[__r0]
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	romx
	pop X
	mov [X+3],A
	mov A,[__r0]
	mov [X+2],A
	.dbline 317
; 			L_Above = ADC2L_80cm[index+1];
	mov A,[X+8]
	add A,1
	mov [__r1],A
	mov A,[X+7]
	adc A,0
	mov [__r0],A
	asl [__r1]
	rlc [__r0]
	add [__r1],<_ADC2L_80cm
	adc [__r0],>_ADC2L_80cm
	mov A,[__r0]
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	romx
	pop X
	mov [X+5],A
	mov A,[__r0]
	mov [X+4],A
	.dbline 318
; 			break;
	xjmp L41
L47:
	.dbline 321
; 			
; 		case 0xFF:	// Debug, Raw ADC value
; 			L_Below = ADC;
	mov A,[X-4]
	mov [X+3],A
	mov A,[X-5]
	mov [X+2],A
	.dbline 322
; 			L_Above = ADC+8;
	mov A,[X-4]
	add A,8
	mov [X+5],A
	mov A,[X-5]
	adc A,0
	mov [X+4],A
	.dbline 323
; 			break;
L40:
L41:
	.dbline 327
; 	}
; 	
; 	// do linear interpolation, assuming every 8th data is in the lookup table
; 	sum = L_Below;								// sum ~ L
	mov A,[X+3]
	mov [X+1],A
	mov A,[X+2]
	mov [X+0],A
	.dbline 328
; 	sum += (ADC & 0x0001) ? L_Above : L_Below;  // sum ~ 2xL
	mov REG[0xd0],>__r0
	mov A,[X-4]
	and A,1
	mov [__r1],A
	mov A,[X-5]
	and A,0
	cmp A,0
	jnz X18
	cmp [__r1],0
	jz L50
X18:
	mov A,[X+5]
	mov [X+12],A
	mov A,[X+4]
	mov [X+11],A
	xjmp L51
L50:
	mov A,[X+3]
	mov [X+12],A
	mov A,[X+2]
	mov [X+11],A
L51:
	mov A,[X+12]
	add [X+1],A
	mov A,[X+11]
	adc [X+0],A
	.dbline 330
; 
; 	L_Above <<=1; L_Below <<=1;
	asl [X+5]
	rlc [X+4]
	.dbline 330
	asl [X+3]
	rlc [X+2]
	.dbline 331
; 	sum += (ADC & 0x0002) ? L_Above : L_Below;	// sum ~ 4xL
	mov REG[0xd0],>__r0
	mov A,[X-4]
	and A,2
	mov [__r1],A
	mov A,[X-5]
	and A,0
	cmp A,0
	jnz X19
	cmp [__r1],0
	jz L53
X19:
	mov A,[X+5]
	mov [X+14],A
	mov A,[X+4]
	mov [X+13],A
	xjmp L54
L53:
	mov A,[X+3]
	mov [X+14],A
	mov A,[X+2]
	mov [X+13],A
L54:
	mov A,[X+14]
	add [X+1],A
	mov A,[X+13]
	adc [X+0],A
	.dbline 332
; 	sum >>=1;									// sum ~ 2xL
	and F,-5
	rrc [X+0]
	rrc [X+1]
	.dbline 333
; 	sum += (ADC & 0x0004) ? L_Above : L_Below;	// sum ~ 4xL
	mov REG[0xd0],>__r0
	mov A,[X-4]
	and A,4
	mov [__r1],A
	mov A,[X-5]
	and A,0
	cmp A,0
	jnz X20
	cmp [__r1],0
	jz L56
X20:
	mov A,[X+5]
	mov [X+16],A
	mov A,[X+4]
	mov [X+15],A
	xjmp L57
L56:
	mov A,[X+3]
	mov [X+16],A
	mov A,[X+2]
	mov [X+15],A
L57:
	mov A,[X+16]
	add [X+1],A
	mov A,[X+15]
	adc [X+0],A
	.dbline 335
; 	
; 	return sum >>2;
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r1],A
	mov A,[X+0]
	mov [__r0],A
	and F,-5
	rrc [__r0]
	rrc [__r1]
	and F,-5
	rrc [__r0]
	rrc [__r1]
	.dbline -2
L39:
	add SP,-17
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l index 7 i
	.dbsym l SensorType 6 c
	.dbsym l L_Above 4 i
	.dbsym l L_Below 2 i
	.dbsym l sum 0 i
	.dbsym l ADC -5 i
	.dbend
	.area lit(rom, con, rel)
_ADC2L_80cm::
	.word 10899
	.word 10702
	.word 10511
	.word 10327
	.word 10148
	.word 9975
	.word 9807
	.word 9645
	.word 9487
	.word 9334
	.word 9186
	.word 9042
	.word 8902
	.word 8766
	.word 8634
	.word 8505
	.word 8380
	.word 8258
	.word 8140
	.word 8025
	.word 7912
	.word 7803
	.word 7696
	.word 7592
	.word 7490
	.word 7391
	.word 7295
	.word 7200
	.word 7108
	.word 7018
	.word 6931
	.word 6845
	.word 6761
	.word 6679
	.word 6599
	.word 6520
	.word 6444
	.word 6368
	.word 6295
	.word 6223
	.word 6153
	.word 6084
	.word 6016
	.word 5950
	.word 5885
	.word 5822
	.word 5759
	.word 5698
	.word 5638
	.word 5580
	.word 5522
	.word 5466
	.word 5410
	.word 5356
	.word 5302
	.word 5250
	.word 5198
	.word 5148
	.word 5098
	.word 5049
	.word 5002
	.word 4954
	.word 4908
	.word 4863
	.word 4818
	.word 4774
	.word 4731
	.word 4688
	.word 4646
	.word 4605
	.word 4565
	.word 4525
	.word 4486
	.word 4447
	.word 4409
	.word 4372
	.word 4335
	.word 4299
	.word 4264
	.word 4228
	.word 4194
	.word 4160
	.word 4126
	.word 4093
	.word 4061
	.word 4029
	.word 3997
	.word 3966
	.word 3935
	.word 3905
	.word 3875
	.word 3846
	.word 3817
	.word 3788
	.word 3760
	.word 3732
	.word 3705
	.word 3677
	.word 3651
	.word 3624
	.word 3598
	.word 3573
	.word 3547
	.word 3522
	.word 3498
	.word 3473
	.word 3449
	.word 3425
	.word 3402
	.word 3379
	.word 3356
	.word 3333
	.word 3311
	.word 3289
	.word 3267
	.word 3246
	.word 3225
	.word 3204
	.word 3183
	.word 3163
	.word 3142
	.word 3122
	.word 3103
	.word 3083
	.word 3064
	.word 3045
	.word 3026
	.word 3007
	.word 2989
	.word 2970
	.word 2952
	.word 2935
	.word 2917
	.word 2900
	.word 2882
	.word 2865
	.word 2848
	.word 2832
	.word 2815
	.word 2799
	.word 2783
	.word 2767
	.word 2751
	.word 2735
	.word 2720
	.word 2704
	.word 2689
	.word 2674
	.word 2659
	.word 2645
	.word 2630
	.word 2616
	.word 2602
	.word 2587
	.word 2573
	.word 2560
	.word 2546
	.word 2532
	.word 2519
	.word 2506
	.word 2493
	.word 2479
	.word 2467
	.word 2454
	.word 2441
	.word 2429
	.word 2416
	.word 2404
	.word 2392
	.word 2380
	.word 2368
	.word 2356
	.word 2344
	.word 2332
	.word 2321
	.word 2309
	.word 2298
	.word 2287
	.word 2276
	.word 2265
	.word 2254
	.word 2243
	.word 2232
	.word 2221
	.word 2211
	.word 2200
	.word 2190
	.word 2180
	.word 2170
	.word 2160
	.word 2150
	.word 2140
	.word 2130
	.word 2120
	.word 2110
	.word 2101
	.word 2091
	.word 2082
	.word 2072
	.word 2063
	.word 2054
	.word 2045
	.word 2036
	.word 2027
	.word 2018
	.word 2009
	.word 2000
	.word 1992
	.word 1983
	.word 1974
	.word 1966
	.word 1958
	.word 1949
	.word 1941
	.word 1933
	.word 1925
	.word 1916
	.word 1908
	.word 1900
	.word 1893
	.word 1885
	.word 1877
	.word 1869
	.word 1862
	.word 1854
	.word 1846
	.word 1839
	.word 1831
	.word 1824
	.word 1817
	.word 1809
	.word 1802
	.word 1795
	.word 1788
	.word 1781
	.word 1774
	.word 1767
	.word 1760
	.word 1753
	.word 1746
	.word 1740
	.word 1733
	.word 1726
	.word 1720
	.word 1713
	.word 1706
	.word 1700
	.word 1694
	.word 1687
	.word 1681
	.word 1675
	.word 1668
	.word 1662
	.word 1656
	.word 1650
	.word 1644
	.word 1638
	.word 1632
	.word 1626
	.word 1620
	.word 1614
	.word 1608
	.word 1602
	.word 1596
	.word 1591
	.word 1585
	.word 1579
	.word 1574
	.word 1568
	.word 1563
	.word 1557
	.word 1552
	.word 1546
	.word 1541
	.word 1535
	.word 1530
	.word 1525
	.word 1519
	.word 1514
	.word 1509
	.word 1504
	.word 1499
	.word 1494
	.word 1489
	.word 1484
	.word 1479
	.word 1474
	.word 1469
	.word 1464
	.word 1459
	.word 1454
	.word 1449
	.word 1444
	.word 1440
	.word 1435
	.word 1430
	.word 1425
	.word 1421
	.word 1416
	.word 1412
	.word 1407
	.word 1403
	.word 1398
	.word 1394
	.word 1389
	.word 1385
	.word 1380
	.word 1376
	.word 1371
	.word 1367
	.word 1363
	.word 1359
	.word 1354
	.word 1350
	.word 1346
	.word 1342
	.word 1338
	.word 1333
	.word 1329
	.word 1325
	.word 1321
	.word 1317
	.word 1313
	.word 1309
	.word 1305
	.word 1301
	.word 1297
	.word 1293
	.word 1289
	.word 1286
	.word 1282
	.word 1278
	.word 1274
	.word 1270
	.word 1267
	.word 1263
	.word 1259
	.word 1255
	.word 1252
	.word 1248
	.word 1244
	.word 1241
	.word 1237
	.word 1234
	.word 1230
	.word 1227
	.word 1223
	.word 1220
	.word 1216
	.word 1213
	.word 1209
	.word 1206
	.word 1202
	.word 1199
	.word 1196
	.word 1192
	.word 1189
	.word 1186
	.word 1182
	.word 1179
	.word 1176
	.word 1172
	.word 1169
	.word 1166
	.word 1163
	.word 1160
	.word 1156
	.word 1153
	.word 1150
	.word 1147
	.word 1144
	.word 1141
	.word 1138
	.word 1135
	.word 1132
	.word 1128
	.word 1125
	.word 1122
	.word 1119
	.word 1116
	.word 1114
	.word 1111
	.word 1108
	.word 1105
	.word 1102
	.word 1099
	.word 1096
	.word 1093
	.word 1090
	.word 1088
	.word 1085
	.word 1082
	.word 1079
	.word 1076
	.word 1074
	.word 1071
	.word 1068
	.word 1065
	.word 1063
	.word 1060
	.word 1057
	.word 1055
	.word 1052
	.word 1049
	.word 1047
	.word 1044
	.word 1041
	.word 1039
	.word 1036
	.word 1034
	.word 1031
	.word 1028
	.word 1026
	.word 1023
	.word 1021
	.word 1018
	.word 1016
	.word 1013
	.word 1011
	.word 1008
	.word 1006
	.word 1004
	.word 1001
	.word 999
	.word 996
	.word 994
	.word 991
	.word 989
	.word 987
	.word 984
	.word 982
	.word 980
	.word 977
	.word 975
	.word 973
	.word 970
	.word 968
	.word 966
	.word 964
	.word 961
	.word 959
	.word 957
	.word 955
	.word 952
	.word 950
	.word 948
	.word 946
	.word 944
	.word 941
	.dbsym e ADC2L_80cm _ADC2L_80cm A[898:449]i
_ADC2L_30cm::
	.word 9521
	.word 9362
	.word 9205
	.word 9050
	.word 8896
	.word 8744
	.word 8595
	.word 8447
	.word 8301
	.word 8157
	.word 8015
	.word 7874
	.word 7736
	.word 7599
	.word 7464
	.word 7332
	.word 7201
	.word 7071
	.word 6944
	.word 6819
	.word 6695
	.word 6574
	.word 6454
	.word 6336
	.word 6220
	.word 6106
	.word 5994
	.word 5884
	.word 5775
	.word 5669
	.word 5564
	.word 5461
	.word 5360
	.word 5261
	.word 5164
	.word 5069
	.word 4975
	.word 4884
	.word 4794
	.word 4706
	.word 4620
	.word 4536
	.word 4454
	.word 4373
	.word 4295
	.word 4218
	.word 4144
	.word 4071
	.word 4000
	.word 3931
	.word 3864
	.word 3798
	.word 3735
	.word 3673
	.word 3614
	.word 3556
	.word 3500
	.word 3446
	.word 3394
	.word 3345
	.word 3298
	.word 3254
	.word 3212
	.word 3171
	.word 3130
	.word 3089
	.word 3049
	.word 3010
	.word 2971
	.word 2933
	.word 2897
	.word 2862
	.word 2829
	.word 2797
	.word 2766
	.word 2737
	.word 2708
	.word 2680
	.word 2652
	.word 2623
	.word 2594
	.word 2565
	.word 2536
	.word 2507
	.word 2478
	.word 2450
	.word 2421
	.word 2393
	.word 2364
	.word 2336
	.word 2307
	.word 2279
	.word 2250
	.word 2222
	.word 2194
	.word 2167
	.word 2142
	.word 2117
	.word 2093
	.word 2071
	.word 2049
	.word 2029
	.word 2009
	.word 1991
	.word 1973
	.word 1957
	.word 1942
	.word 1929
	.word 1917
	.word 1907
	.word 1898
	.word 1890
	.word 1882
	.word 1872
	.word 1862
	.word 1850
	.word 1837
	.word 1823
	.word 1808
	.word 1792
	.word 1776
	.word 1758
	.word 1740
	.word 1721
	.word 1701
	.word 1681
	.word 1661
	.word 1643
	.word 1626
	.word 1610
	.word 1594
	.word 1579
	.word 1565
	.word 1551
	.word 1538
	.word 1526
	.word 1514
	.word 1503
	.word 1493
	.word 1483
	.word 1473
	.word 1464
	.word 1454
	.word 1444
	.word 1433
	.word 1423
	.word 1413
	.word 1403
	.word 1392
	.word 1382
	.word 1372
	.word 1362
	.word 1353
	.word 1343
	.word 1334
	.word 1325
	.word 1315
	.word 1307
	.word 1298
	.word 1289
	.word 1280
	.word 1272
	.word 1263
	.word 1255
	.word 1247
	.word 1238
	.word 1230
	.word 1222
	.word 1214
	.word 1206
	.word 1198
	.word 1190
	.word 1182
	.word 1175
	.word 1167
	.word 1160
	.word 1152
	.word 1145
	.word 1138
	.word 1131
	.word 1124
	.word 1117
	.word 1110
	.word 1103
	.word 1097
	.word 1090
	.word 1083
	.word 1077
	.word 1071
	.word 1064
	.word 1058
	.word 1052
	.word 1046
	.word 1040
	.word 1034
	.word 1029
	.word 1023
	.word 1017
	.word 1012
	.word 1006
	.word 1001
	.word 995
	.word 990
	.word 985
	.word 980
	.word 975
	.word 970
	.word 965
	.word 961
	.word 956
	.word 952
	.word 948
	.word 943
	.word 939
	.word 935
	.word 931
	.word 927
	.word 923
	.word 918
	.word 914
	.word 910
	.word 906
	.word 902
	.word 898
	.word 894
	.word 890
	.word 886
	.word 882
	.word 879
	.word 875
	.word 871
	.word 868
	.word 864
	.word 861
	.word 857
	.word 854
	.word 850
	.word 847
	.word 844
	.word 841
	.word 837
	.word 834
	.word 831
	.word 828
	.word 824
	.word 821
	.word 818
	.word 814
	.word 811
	.word 808
	.word 805
	.word 801
	.word 798
	.word 795
	.word 791
	.word 788
	.word 785
	.word 782
	.word 778
	.word 775
	.word 772
	.word 769
	.word 765
	.word 762
	.word 759
	.word 756
	.word 753
	.word 749
	.word 746
	.word 743
	.word 740
	.word 737
	.word 734
	.word 731
	.word 728
	.word 725
	.word 722
	.word 719
	.word 716
	.word 713
	.word 710
	.word 707
	.word 704
	.word 701
	.word 698
	.word 695
	.word 693
	.word 690
	.word 687
	.word 684
	.word 682
	.word 679
	.word 676
	.word 674
	.word 671
	.word 668
	.word 666
	.word 663
	.word 661
	.word 658
	.word 656
	.word 653
	.word 651
	.word 648
	.word 646
	.word 643
	.word 641
	.word 638
	.word 636
	.word 634
	.word 631
	.word 629
	.word 627
	.word 624
	.word 622
	.word 619
	.word 617
	.word 615
	.word 612
	.word 610
	.word 608
	.word 605
	.word 603
	.word 601
	.word 599
	.word 596
	.word 594
	.word 592
	.word 590
	.word 587
	.word 585
	.word 583
	.word 581
	.word 579
	.word 576
	.word 574
	.word 572
	.word 570
	.word 568
	.word 566
	.word 564
	.word 562
	.word 559
	.word 557
	.word 555
	.word 553
	.word 551
	.word 549
	.word 547
	.word 545
	.word 543
	.word 541
	.word 539
	.word 537
	.word 536
	.word 534
	.word 532
	.word 530
	.word 528
	.word 526
	.word 524
	.word 522
	.word 520
	.word 518
	.word 516
	.word 515
	.word 513
	.word 511
	.word 509
	.word 507
	.word 505
	.word 504
	.word 502
	.word 500
	.word 498
	.word 496
	.word 495
	.word 493
	.word 491
	.word 489
	.word 488
	.word 486
	.word 484
	.word 483
	.word 481
	.word 479
	.word 478
	.word 476
	.word 474
	.word 473
	.word 471
	.word 470
	.word 468
	.word 466
	.word 465
	.word 463
	.word 462
	.word 460
	.word 459
	.word 457
	.word 456
	.word 454
	.word 453
	.word 452
	.word 450
	.word 449
	.word 447
	.word 446
	.word 445
	.word 443
	.word 442
	.word 440
	.word 439
	.word 438
	.word 436
	.word 435
	.word 433
	.word 432
	.word 431
	.word 429
	.word 428
	.word 427
	.word 425
	.word 424
	.word 422
	.word 421
	.word 420
	.word 418
	.word 417
	.word 416
	.word 414
	.word 413
	.word 411
	.word 410
	.word 409
	.word 407
	.word 406
	.word 404
	.word 403
	.word 402
	.word 400
	.word 399
	.word 398
	.word 396
	.word 395
	.word 394
	.word 393
	.word 392
	.word 392
	.word 391
	.word 391
	.word 391
	.word 391
	.word 391
	.word 391
	.word 391
	.word 392
	.word 393
	.word 393
	.word 394
	.word 395
	.word 395
	.word 396
	.word 396
	.word 395
	.word 395
	.word 394
	.word 392
	.word 391
	.word 389
	.word 386
	.word 383
	.word 380
	.word 377
	.word 373
	.word 368
	.word 364
	.word 359
	.word 354
	.word 349
	.word 343
	.word 337
	.word 331
	.word 325
	.word 319
	.word 312
	.word 305
	.word 298
	.word 291
	.word 283
	.word 276
	.word 268
	.word 260
	.word 251
	.word 243
	.word 234
	.word 225
	.word 216
	.word 207
	.word 197
	.word 187
	.word 177
	.word 167
	.word 156
	.word 146
	.word 135
	.word 124
	.word 113
	.word 101
	.word 89
	.word 77
	.word 65
	.word 53
	.dbsym e ADC2L_30cm _ADC2L_30cm A[1026:513]i
	.area text(rom, con, rel)
	.dbfile ./sensor.c
	.dbfunc e Sensor_Debug _Sensor_Debug fV
_Sensor_Debug::
	.dbline -1
	.dbline 1311
; }
; 
; 
; const WORD ADC2L_80cm[] =	// table lists every 8th distance value, starting at ADC=512
; {
; 	10899,// ADC=512  =>  L=1089.9mm
; 	10702,// ADC=520  => L=1070.2mm
; 	10511,// 
; 	10327,
; 	10148,
; 	9975,
; 	9807,
; 	9645,
; 	9487,
; 	9334,
; 	9186,
; 	9042,
; 	8902,
; 	8766,
; 	8634,
; 	8505,
; 	8380,
; 	8258,
; 	8140,
; 	8025,
; 	7912,
; 	7803,
; 	7696,
; 	7592,
; 	7490,
; 	7391,
; 	7295,
; 	7200,
; 	7108,
; 	7018,
; 	6931,
; 	6845,
; 	6761,
; 	6679,
; 	6599,
; 	6520,
; 	6444,
; 	6368,
; 	6295,
; 	6223,
; 	6153,
; 	6084,
; 	6016,
; 	5950,
; 	5885,
; 	5822,
; 	5759,
; 	5698,
; 	5638,
; 	5580,
; 	5522,
; 	5466,
; 	5410,
; 	5356,
; 	5302,
; 	5250,
; 	5198,
; 	5148,
; 	5098,
; 	5049,
; 	5002,
; 	4954,
; 	4908,
; 	4863,
; 	4818,
; 	4774,
; 	4731,
; 	4688,
; 	4646,
; 	4605,
; 	4565,
; 	4525,
; 	4486,
; 	4447,
; 	4409,
; 	4372,
; 	4335,
; 	4299,
; 	4264,
; 	4228,
; 	4194,
; 	4160,
; 	4126,
; 	4093,
; 	4061,
; 	4029,
; 	3997,
; 	3966,
; 	3935,
; 	3905,
; 	3875,
; 	3846,
; 	3817,
; 	3788,
; 	3760,
; 	3732,
; 	3705,
; 	3677,
; 	3651,
; 	3624,
; 	3598,
; 	3573,
; 	3547,
; 	3522,
; 	3498,
; 	3473,
; 	3449,
; 	3425,
; 	3402,
; 	3379,
; 	3356,
; 	3333,
; 	3311,
; 	3289,
; 	3267,
; 	3246,
; 	3225,
; 	3204,
; 	3183,
; 	3163,
; 	3142,
; 	3122,
; 	3103,
; 	3083,
; 	3064,
; 	3045,
; 	3026,
; 	3007,
; 	2989,
; 	2970,
; 	2952,
; 	2935,
; 	2917,
; 	2900,
; 	2882,
; 	2865,
; 	2848,
; 	2832,
; 	2815,
; 	2799,
; 	2783,
; 	2767,
; 	2751,
; 	2735,
; 	2720,
; 	2704,
; 	2689,
; 	2674,
; 	2659,
; 	2645,
; 	2630,
; 	2616,
; 	2602,
; 	2587,
; 	2573,
; 	2560,
; 	2546,
; 	2532,
; 	2519,
; 	2506,
; 	2493,
; 	2479,
; 	2467,
; 	2454,
; 	2441,
; 	2429,
; 	2416,
; 	2404,
; 	2392,
; 	2380,
; 	2368,
; 	2356,
; 	2344,
; 	2332,
; 	2321,
; 	2309,
; 	2298,
; 	2287,
; 	2276,
; 	2265,
; 	2254,
; 	2243,
; 	2232,
; 	2221,
; 	2211,
; 	2200,
; 	2190,
; 	2180,
; 	2170,
; 	2160,
; 	2150,
; 	2140,
; 	2130,
; 	2120,
; 	2110,
; 	2101,
; 	2091,
; 	2082,
; 	2072,
; 	2063,
; 	2054,
; 	2045,
; 	2036,
; 	2027,
; 	2018,
; 	2009,
; 	2000,
; 	1992,
; 	1983,
; 	1974,
; 	1966,
; 	1958,
; 	1949,
; 	1941,
; 	1933,
; 	1925,
; 	1916,
; 	1908,
; 	1900,
; 	1893,
; 	1885,
; 	1877,
; 	1869,
; 	1862,
; 	1854,
; 	1846,
; 	1839,
; 	1831,
; 	1824,
; 	1817,
; 	1809,
; 	1802,
; 	1795,
; 	1788,
; 	1781,
; 	1774,
; 	1767,
; 	1760,
; 	1753,
; 	1746,
; 	1740,
; 	1733,
; 	1726,
; 	1720,
; 	1713,
; 	1706,
; 	1700,
; 	1694,
; 	1687,
; 	1681,
; 	1675,
; 	1668,
; 	1662,
; 	1656,
; 	1650,
; 	1644,
; 	1638,
; 	1632,
; 	1626,
; 	1620,
; 	1614,
; 	1608,
; 	1602,
; 	1596,
; 	1591,
; 	1585,
; 	1579,
; 	1574,
; 	1568,
; 	1563,
; 	1557,
; 	1552,
; 	1546,
; 	1541,
; 	1535,
; 	1530,
; 	1525,
; 	1519,
; 	1514,
; 	1509,
; 	1504,
; 	1499,
; 	1494,
; 	1489,
; 	1484,
; 	1479,
; 	1474,
; 	1469,
; 	1464,
; 	1459,
; 	1454,
; 	1449,
; 	1444,
; 	1440,
; 	1435,
; 	1430,
; 	1425,
; 	1421,
; 	1416,
; 	1412,
; 	1407,
; 	1403,
; 	1398,
; 	1394,
; 	1389,
; 	1385,
; 	1380,
; 	1376,
; 	1371,
; 	1367,
; 	1363,
; 	1359,
; 	1354,
; 	1350,
; 	1346,
; 	1342,
; 	1338,
; 	1333,
; 	1329,
; 	1325,
; 	1321,
; 	1317,
; 	1313,
; 	1309,
; 	1305,
; 	1301,
; 	1297,
; 	1293,
; 	1289,
; 	1286,
; 	1282,
; 	1278,
; 	1274,
; 	1270,
; 	1267,
; 	1263,
; 	1259,
; 	1255,
; 	1252,
; 	1248,
; 	1244,
; 	1241,
; 	1237,
; 	1234,
; 	1230,
; 	1227,
; 	1223,
; 	1220,
; 	1216,
; 	1213,
; 	1209,
; 	1206,
; 	1202,
; 	1199,
; 	1196,
; 	1192,
; 	1189,
; 	1186,
; 	1182,
; 	1179,
; 	1176,
; 	1172,
; 	1169,
; 	1166,
; 	1163,
; 	1160,
; 	1156,
; 	1153,
; 	1150,
; 	1147,
; 	1144,
; 	1141,
; 	1138,
; 	1135,
; 	1132,
; 	1128,
; 	1125,
; 	1122,
; 	1119,
; 	1116,
; 	1114,
; 	1111,
; 	1108,
; 	1105,
; 	1102,
; 	1099,
; 	1096,
; 	1093,
; 	1090,
; 	1088,
; 	1085,
; 	1082,
; 	1079,
; 	1076,
; 	1074,
; 	1071,
; 	1068,
; 	1065,
; 	1063,
; 	1060,
; 	1057,
; 	1055,
; 	1052,
; 	1049,
; 	1047,
; 	1044,
; 	1041,
; 	1039,
; 	1036,
; 	1034,
; 	1031,
; 	1028,
; 	1026,
; 	1023,
; 	1021,
; 	1018,
; 	1016,
; 	1013,
; 	1011,
; 	1008,
; 	1006,
; 	1004,
; 	1001,
; 	999,
; 	996,
; 	994,
; 	991,
; 	989,
; 	987,
; 	984,
; 	982,
; 	980,
; 	977,
; 	975,
; 	973,
; 	970,
; 	968,
; 	966,
; 	964,
; 	961,
; 	959,
; 	957,
; 	955,
; 	952,
; 	950,
; 	948,
; 	946,// 
; 	944,// ADC=4088  => L=94.4mm
; 	941// ADC=4096 (does not exist)  => L=94.1mm
; };
; 
; const WORD ADC2L_30cm[513] =// table lists every 8th distance value, starting at ADC=512
; {
; 9521,// ADC=0  =>  L=952.1mm
; 9362,// ADC=8  => L=936.2mm
; 9205,// 
; 9050,
; 8896,
; 8744,
; 8595,
; 8447,
; 8301,
; 8157,
; 8015,
; 7874,
; 7736,
; 7599,
; 7464,
; 7332,
; 7201,
; 7071,
; 6944,
; 6819,
; 6695,
; 6574,
; 6454,
; 6336,
; 6220,
; 6106,
; 5994,
; 5884,
; 5775,
; 5669,
; 5564,
; 5461,
; 5360,
; 5261,
; 5164,
; 5069,
; 4975,
; 4884,
; 4794,
; 4706,
; 4620,
; 4536,
; 4454,
; 4373,
; 4295,
; 4218,
; 4144,
; 4071,
; 4000,
; 3931,
; 3864,
; 3798,
; 3735,
; 3673,
; 3614,
; 3556,
; 3500,
; 3446,
; 3394,
; 3345,
; 3298,
; 3254,
; 3212,
; 3171,
; 3130,
; 3089,
; 3049,
; 3010,
; 2971,
; 2933,
; 2897,
; 2862,
; 2829,
; 2797,
; 2766,
; 2737,
; 2708,
; 2680,
; 2652,
; 2623,
; 2594,
; 2565,
; 2536,
; 2507,
; 2478,
; 2450,
; 2421,
; 2393,
; 2364,
; 2336,
; 2307,
; 2279,
; 2250,
; 2222,
; 2194,
; 2167,
; 2142,
; 2117,
; 2093,
; 2071,
; 2049,
; 2029,
; 2009,
; 1991,
; 1973,
; 1957,
; 1942,
; 1929,
; 1917,
; 1907,
; 1898,
; 1890,
; 1882,
; 1872,
; 1862,
; 1850,
; 1837,
; 1823,
; 1808,
; 1792,
; 1776,
; 1758,
; 1740,
; 1721,
; 1701,
; 1681,
; 1661,
; 1643,
; 1626,
; 1610,
; 1594,
; 1579,
; 1565,
; 1551,
; 1538,
; 1526,
; 1514,
; 1503,
; 1493,
; 1483,
; 1473,
; 1464,
; 1454,
; 1444,
; 1433,
; 1423,
; 1413,
; 1403,
; 1392,
; 1382,
; 1372,
; 1362,
; 1353,
; 1343,
; 1334,
; 1325,
; 1315,
; 1307,
; 1298,
; 1289,
; 1280,
; 1272,
; 1263,
; 1255,
; 1247,
; 1238,
; 1230,
; 1222,
; 1214,
; 1206,
; 1198,
; 1190,
; 1182,
; 1175,
; 1167,
; 1160,
; 1152,
; 1145,
; 1138,
; 1131,
; 1124,
; 1117,
; 1110,
; 1103,
; 1097,
; 1090,
; 1083,
; 1077,
; 1071,
; 1064,
; 1058,
; 1052,
; 1046,
; 1040,
; 1034,
; 1029,
; 1023,
; 1017,
; 1012,
; 1006,
; 1001,
; 995,
; 990,
; 985,
; 980,
; 975,
; 970,
; 965,
; 961,
; 956,
; 952,
; 948,
; 943,
; 939,
; 935,
; 931,
; 927,
; 923,
; 918,
; 914,
; 910,
; 906,
; 902,
; 898,
; 894,
; 890,
; 886,
; 882,
; 879,
; 875,
; 871,
; 868,
; 864,
; 861,
; 857,
; 854,
; 850,
; 847,
; 844,
; 841,
; 837,
; 834,
; 831,
; 828,
; 824,
; 821,
; 818,
; 814,
; 811,
; 808,
; 805,
; 801,
; 798,
; 795,
; 791,
; 788,
; 785,
; 782,
; 778,
; 775,
; 772,
; 769,
; 765,
; 762,
; 759,
; 756,
; 753,
; 749,
; 746,
; 743,
; 740,
; 737,
; 734,
; 731,
; 728,
; 725,
; 722,
; 719,
; 716,
; 713,
; 710,
; 707,
; 704,
; 701,
; 698,
; 695,
; 693,
; 690,
; 687,
; 684,
; 682,
; 679,
; 676,
; 674,
; 671,
; 668,
; 666,
; 663,
; 661,
; 658,
; 656,
; 653,
; 651,
; 648,
; 646,
; 643,
; 641,
; 638,
; 636,
; 634,
; 631,
; 629,
; 627,
; 624,
; 622,
; 619,
; 617,
; 615,
; 612,
; 610,
; 608,
; 605,
; 603,
; 601,
; 599,
; 596,
; 594,
; 592,
; 590,
; 587,
; 585,
; 583,
; 581,
; 579,
; 576,
; 574,
; 572,
; 570,
; 568,
; 566,
; 564,
; 562,
; 559,
; 557,
; 555,
; 553,
; 551,
; 549,
; 547,
; 545,
; 543,
; 541,
; 539,
; 537,
; 536,
; 534,
; 532,
; 530,
; 528,
; 526,
; 524,
; 522,
; 520,
; 518,
; 516,
; 515,
; 513,
; 511,
; 509,
; 507,
; 505,
; 504,
; 502,
; 500,
; 498,
; 496,
; 495,
; 493,
; 491,
; 489,
; 488,
; 486,
; 484,
; 483,
; 481,
; 479,
; 478,
; 476,
; 474,
; 473,
; 471,
; 470,
; 468,
; 466,
; 465,
; 463,
; 462,
; 460,
; 459,
; 457,
; 456,
; 454,
; 453,
; 452,
; 450,
; 449,
; 447,
; 446,
; 445,
; 443,
; 442,
; 440,
; 439,
; 438,
; 436,
; 435,
; 433,
; 432,
; 431,
; 429,
; 428,
; 427,
; 425,
; 424,
; 422,
; 421,
; 420,
; 418,
; 417,
; 416,
; 414,
; 413,
; 411,
; 410,
; 409,
; 407,
; 406,
; 404,
; 403,
; 402,
; 400,
; 399,
; 398,
; 396,
; 395,
; 394,
; 393,
; 392,
; 392,
; 391,
; 391,
; 391,
; 391,
; 391,
; 391,
; 391,
; 392,
; 393,
; 393,
; 394,
; 395,
; 395,
; 396,
; 396,
; 395,
; 395,
; 394,
; 392,
; 391,
; 389,
; 386,
; 383,
; 380,
; 377,
; 373,
; 368,
; 364,
; 359,
; 354,
; 349,
; 343,
; 337,
; 331,
; 325,
; 319,
; 312,
; 305,
; 298,
; 291,
; 283,
; 276,
; 268,
; 260,
; 251,
; 243,
; 234,
; 225,
; 216,
; 207,
; 197,
; 187,
; 177,
; 167,
; 156,
; 146,
; 135,
; 124,
; 113,
; 101,
; 89,
; 77,// 
; 65,// ADC=4088  => L=0.65mm
; 53// ADC=4096 (does not exist)  => L=0.53mm
; };
; 
; //-----------------------------------------------------------------------------
; void Sensor_Debug(void)
; {
	.dbline -2
	.dbline 1313
; /* currently no debug function */
; }
L58:
	.dbline 0 ; func end
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_ARF::
	.byte 0
	.dbsym e ARF _ARF c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM2_0::
	.byte 0
	.dbsym e DM2_0 _DM2_0 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM2_1::
	.byte 0
	.dbsym e DM2_1 _DM2_1 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM2_2::
	.byte 0
	.dbsym e DM2_2 _DM2_2 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM0_0::
	.byte 0
	.dbsym e DM0_0 _DM0_0 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM0_1::
	.byte 0
	.dbsym e DM0_1 _DM0_1 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM0_2::
	.byte 0
	.dbsym e DM0_2 _DM0_2 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_Countdown_1ms::
	.byte 0,0
	.dbsym e Countdown_1ms _Countdown_1ms i
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_FSM::
	.byte 0
	.dbsym e FSM _FSM c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_Report::
	.byte 0,0,0,0
	.dbsym e Report _Report X
